package Aufgabe1;

import java.io.*;
import java.net.Socket;


public class ChatClient implements Runnable {
	static BufferedReader netIn;
	static BufferedWriter netOut;
	static BufferedReader cIn;
	static Socket sock;
	
	public static void main(String[] args) throws Exception {
		String user=args[2];
		sock = new Socket(args[0], Integer.parseInt(args[1]));
		netIn = new BufferedReader(new InputStreamReader(sock.getInputStream()));
		netOut = new BufferedWriter(new OutputStreamWriter(sock.getOutputStream()));
		System.out.println("*** socket " + sock + " connected ***");
		
		cIn = new BufferedReader(new InputStreamReader(System.in));
		
		// Thread für Empfang starten
		Thread t = new Thread(new ChatClient());
		t.start();
		
		// Konsoleneingaben senden
		String line;
		while ((line = cIn.readLine()) != null) {
			
			//if (line.length()>=5){
				//if(line.substring(0,5).equals("/quit")){
			if(line.startsWith("/quit")){
				netOut.write("*** socket " + sock + " disconnected ***");
				netOut.flush();
				break;
			}
				//}
			//}
			
			netOut.write(user+": "+line + "\n");
			netOut.flush();
			
			
		}
		
		System.out.println("*** closing send stream ***");		
		sock.shutdownOutput();
		
		// Warten bis Empfangsthread auch fertig ist, dann Socket schließen
		t.join();
		System.out.println("*** closing socket ***");		
		sock.close();
	}

	
	// run-Methode für den Empfangsthread
	@Override
	public void run() {
		try {
			String line;
			while ((line = netIn.readLine()) != null) {
				System.out.println(line);
			}
			
			System.out.println("*** end of receive stream ***");		
			sock.shutdownInput();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}

